#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>

__attribute__((noreturn, format(printf, 1, 2))) static void die(const char *fmt, ...) {
    va_list args;

    va_start(args, fmt);
    vfprintf(stderr, fmt, args);
    va_end(args);
    putchar('\n');

    exit(1);
}

#define ARRAY_SIZE(__x) (sizeof(__x) / sizeof((__x)[0]))

#define TEST_EQ(__x, __y)                   \
    do {                                    \
        if ((__x) != (__y))                 \
            die("TEST_EQ: %d", __LINE__);   \
    } while (0)
