// Usage:
// nasm -f elf32 max.asm -o max.asm.o && gcc -c max.c -o max.c.o && gcc -static max.{c,asm}.o -o max && rm max.{c,asm}.o && ./max

#include "common.h"

extern int max(int *array, int size);
extern int maxcount(int *array, int size);

int main(void) {
    {
        int a[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 13, 13, -1, -5, -100}, as = ARRAY_SIZE(a);
        TEST_EQ(max(a, as), 13);
        TEST_EQ(max(a, as), 13);
        TEST_EQ(max(a, as), 13);
        TEST_EQ(max(a, as), 13);
        TEST_EQ(max(a, as), 13);
        TEST_EQ(max(a, as), 13);
        TEST_EQ(maxcount(a, as), 3);
        TEST_EQ(maxcount(a, as), 3);
        TEST_EQ(maxcount(a, as), 3);
        TEST_EQ(maxcount(a, as), 3);
        TEST_EQ(maxcount(a, as), 3);
    }

    {
        int a[] = {-1000}, as = ARRAY_SIZE(a);
        TEST_EQ(max(a, as), -1000);
        TEST_EQ(maxcount(a, as), 1);
        TEST_EQ(max(a, as), -1000);
        TEST_EQ(maxcount(a, as), 1);
        TEST_EQ(max(a, as), -1000);
        TEST_EQ(maxcount(a, as), 1);
        TEST_EQ(max(a, as), -1000);
        TEST_EQ(maxcount(a, as), 1);
    }

    {
        int a[] = {1, 2, 3, 4, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 13, 13, -1, -5, -100}, as = 5;
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(maxcount(a, as), 2);
        TEST_EQ(maxcount(a, as), 2);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(maxcount(a, as), 2);
        TEST_EQ(maxcount(a, as), 2);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(max(a, as), 4);
        TEST_EQ(maxcount(a, as), 2);
    }

    return 0;
}
