// Usage:
// nasm -f elf32 pal.asm -o pal.asm.o && gcc -c pal.c -o pal.c.o && gcc -static pal.{c,asm}.o -o pal && rm pal.{c,asm}.o && ./pal

#include "common.h"

extern int palindrome(int number);
extern int palcount(int *array, int size);

int main(void) {
    {
        TEST_EQ(palindrome(0), 1);

        TEST_EQ(palindrome(1), 1);
        TEST_EQ(palindrome(11), 1);
        TEST_EQ(palindrome(111), 1);
        TEST_EQ(palindrome(1111), 1);
        TEST_EQ(palindrome(1221), 1);
        TEST_EQ(palindrome(777777777), 1);
        TEST_EQ(palindrome(676), 1);
        TEST_EQ(palindrome(1001), 1);

        TEST_EQ(palindrome(1000), 0);
        TEST_EQ(palindrome(1002), 0);
        TEST_EQ(palindrome(15), 0);
        TEST_EQ(palindrome(73), 0);
        TEST_EQ(palindrome(123456789), 0);

        TEST_EQ(palindrome(-1), 1);
        TEST_EQ(palindrome(-11), 1);
        TEST_EQ(palindrome(-111), 1);
        TEST_EQ(palindrome(-1111), 1);
        TEST_EQ(palindrome(-1221), 1);
        TEST_EQ(palindrome(-777777777), 1);
        TEST_EQ(palindrome(-676), 1);
        TEST_EQ(palindrome(-1001), 1);

        TEST_EQ(palindrome(-1000), 0);
        TEST_EQ(palindrome(-1002), 0);
        TEST_EQ(palindrome(-15), 0);
        TEST_EQ(palindrome(-73), 0);
        TEST_EQ(palindrome(-123456789), 0);
    }

    {
        int a[] = {1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 13, 13, -1, -5, -100}, as = ARRAY_SIZE(a);
        TEST_EQ(palcount(a, 0), 0);
        TEST_EQ(palcount(a, 4), 4);
        TEST_EQ(palcount(a + 10, 3), 1);
        TEST_EQ(palcount(a + 15, 3), 2);
    }

    return 0;
}
