// Usage:
// nasm -f elf32 prime.asm -o prime.asm.o && gcc -c prime.c -o prime.c.o && gcc -static prime.{c,asm}.o -o prime && rm prime.{c,asm}.o && ./prime

#include "common.h"

extern int isprime(int number);

static int isprime_local(int number) {
    for (int i = 2; i * i <= number; ++i) {
        if (number % i == 0)
            return 0;
    }
    return 1;
}

int main(void) {
    {
        for (int i = 1; i != 10000000; ++i)
            TEST_EQ(isprime(i), isprime_local(i));
    }
    return 0;
}
