// Usage:
// nasm -f elf32 reverse.asm -o reverse.asm.o && gcc -c reverse.c -o reverse.c.o && gcc -static reverse.{c,asm}.o -o reverse && rm reverse.{c,asm}.o && ./reverse

#include "common.h"

extern void reverse(int *array, int size);

int main(void) {
    {
        reverse(NULL, 0);
    }

    {
        int a[] = {1, 2, 3, 4, 5, 6, 7, 8, 9};
        int b[] = {1, 2, 3, 4, 5, 6, 7, 8, 9};
        int s = 9;
    
        reverse(a, 9);

        for (int i = 0; i != s; ++i)
            TEST_EQ(a[i], b[s - i - 1]);
    }

    {
        int s = 65536;
        int a[s];

        for (int i = 0; i != s; ++i)
            a[i] = i;
    
        reverse(a, s);

        for (int i = 0; i != s; ++i)
            TEST_EQ(a[i], s - i - 1);
    }

    return 0;
}
