// Usage:
// nasm -f elf32 sum.asm -o sum.asm.o && gcc -c sum.c -o sum.c.o && gcc -static sum.{c,asm}.o -o sum && rm sum.{c,asm}.o && ./sum

#include "common.h"

extern void sum(int *lhs, int *rhs, int *dest, int size);

int main(void) {
    {
        sum(NULL, NULL, NULL, 0);
    }

    {
        int a[] = {1, 2, 3, 4, 5, 6, 7, 8, 9};
        int b[9];
    
        sum(a, a, b, 9);

        for (int i = 0; i != 9; ++i)
            TEST_EQ(a[i] * 2, b[i]);
    }

    {
        int s = 65536;
        int a[s];

        for (int i = 0; i != s; ++i)
            a[i] = i;
    
        sum(a, a, a, s);

        for (int i = 0; i != s; ++i)
            TEST_EQ(a[i], i * 2);
    }

    return 0;
}
