// Usage:
// nasm -f elf32 symmetric.asm -o symmetric.asm.o && gcc -c symmetric.c -o symmetric.c.o && gcc -static symmetric.{c,asm}.o -o symmetric && rm symmetric.{c,asm}.o && ./symmetric

#include "common.h"

extern int symmetric(int *array, int size);

int main(void) {
    {
        TEST_EQ(symmetric(NULL, 0), 1);
    }

    {
        int a[] = {1, 2, 3, 4, 5, 6, 7, 8, 9}, as = ARRAY_SIZE(a);
        TEST_EQ(symmetric(a, as), 0);
    }

    {
        int a[] = {1}, as = ARRAY_SIZE(a);
        TEST_EQ(symmetric(a, as), 1);
    }

    {
        int a[] = {1, 1}, as = ARRAY_SIZE(a);
        TEST_EQ(symmetric(a, as), 1);
    }

    {
        int a[] = {1, 2, 2, 1}, as = ARRAY_SIZE(a);
        TEST_EQ(symmetric(a, as), 1);
    }

    {
        int a[] = {1, 2, 3, 3, 2, 1}, as = ARRAY_SIZE(a);
        TEST_EQ(symmetric(a, as), 1);
    }

    {
        int a[] = {1, 2, 3, 4, 4, 3, 2, 1}, as = ARRAY_SIZE(a);
        TEST_EQ(symmetric(a, as), 1);
    }

    {
        int a[] = {1, 2, 3, 4, 3, 2, 1}, as = ARRAY_SIZE(a);
        TEST_EQ(symmetric(a, as), 1);
    }

    {
        int a[1048576], as = ARRAY_SIZE(a);

        for (int i = 0, ie = as / 2; i != ie; ++i)
            a[i] = a[as - i - 1] = i;
    
        TEST_EQ(symmetric(a, as), 1);
    }

    return 0;
}
